*:*********************************************************************
*:
*:      Program: QUERY for dBase queries
*:       Author: Jon Brammeier
*:    Copyright (c) 1988,89 Jon Brammeier
*:
*:*********************************************************************
PARA mainfile
SET EXCLUSIVE OFF                                && for network support
PUBLIC ifile
ifile=""
oldrow=ROW()
SAVE SCRE TO tscrn
openline=' QUERY (for dBase queries) Version 1.2 '+;
   ' by Jon Brammeier  (C)opyright 1988,89'
SET CURSOR OFF
PUBLIC color1, color2
IF ISCOLOR()
   color1="BG/N,GR+/B,,,BG+/N"
   color2="W/R+"
ELSE
   color1="W/N"
   color2="N/W"
ENDIF
SET COLOR TO &color1
CLEAR
IF Pcount()=0
   DO opening
   numdbf=Adir("*.dbf")
   DO WHILE numdbf=0
      newpath=bottomline('No DBF files found - enter new path',1)
      IF EMPTY(newpath)
         DO ending
      ENDIF
      SET DEFAULT TO &newpath
      numdbf=Adir("*.dbf")
   ENDDO
   bottomline('No DBF file entered ... pick one, then press Enter')
   DECLARE dbf_files[numdbf]
   Adir("*.dbf",dbf_files)
   Asort(dbf_files)
   IF numdbf>16                                    && determine if too many
      numdbf=16                                    &&   to fit on screen
   ENDIF
   @ 6,33 TO 7+numdbf,47 DOUBLE
   pickit=Achoice(7,34,6+numdbf,46,m->dbf_files)     && pick the file
   IF pickit=0
      DO ending
   ENDIF
   mainfile=TRIM(dbf_files[pickit])
ELSE
   @ 23,0 TO 23,79
   bottomline(openline)
   INKEY(2)                                         && wait 2 seconds
   IF AT('*',mainfile)>0 .OR. AT('?',mainfile)>0
      bottomline('Wildcards are not allowed in the filename',0)
      DO ending
   ENDIF
   IF AT('.',mainfile)=0
      mainfile=TRIM(mainfile)+'.dbf'                 && add the extension
   ELSE
      IF AT('.DBF',UPPER(mainfile))=0
         bottomline('This is not a DBF file',0)
         DO ending
      ENDIF
   ENDIF
   IF !FILE(mainfile)
      bottomline('File not found',0)
      DO ending
   ENDIF
ENDIF
IF !net_use(mainfile)
   bottomline('Unable to access file or file is locked',0)
   DO ending
ENDIF
IF lastrec()=0
   bottomline(mainfile+' is empty',0)
   DO ending
ENDIF
EXTERNAL SOUNDEX
*****initialization***********************************************************
***
*** srchstrg,selstrg,srtstrg,swrstrg - are used to hold the SELECT string
***   at various stages throughout. At any point, it may need to go back
***   to the previous version of the string.
***
*** critext - is the string that holds the filter for the WHERE clause
***
*** indxby - contains the fieldnames on which to index
*** indxnew - so the system knows if the index criterion is new
***
*** selall - if ALL fields are selected
*** fscnt - how many fields have been selected individually
***
*** The arrays:
***    c_fld and c_typ - are the master arrays for the fieldnames
***                      and fieldtypes.
***    a_fld    - array of fieldnames to select from on-screen
***    a_fldtyp - field types to go with a_fld
***    a_fldlen - used to track number of elements in the array
***    a_fldsel - the fields selected in the SELECT section
***    a_numtyp - the numeric fields for use in summing in DISPLAY section
***    opers    - a listing of the operators used in the WHERE section
***    preface  - IS and IS NOT for the WHERE section
***    alevel   - these are the names of the functions to run
***
**************************************************************************
PUBLIC bottstrg,srchstrg,selstrg,srtstrg,swrstrg,critext,indxby,indxnew
bottstrg="Press ESC to backtrack - F10 when done"
srchstrg="SELECT ___ SORTED BY ___ WHERE ___"
indxby=""
PUBLIC numflds,a_fldlen
numflds=Fcount()
PUBLIC a_fld[M->numflds+1],a_fldtyp[M->numflds]       && declare field arrays
PUBLIC a_fldsel[M->numflds],a_numtyp[M->numflds]
PUBLIC c_fld[M->numflds],c_typ[M->numflds]
Afields(c_fld,c_typ)
PUBLIC numcnt                                    && number of numeric fields
numcnt=0
FOR J=1 TO m->numflds
   c_fld[M->j]=LOWER(c_fld[M->j])
   IF c_typ[M->j]='N'
      numcnt=m->numcnt+1                         && initializes var for count
      a_numtyp[M->numcnt]=c_fld[M->j]            &&    of numeric fields
   ENDIF
NEXT
PUBLIC opers[9]                                  && operators for where clause
opers[1]='EQ  [ =  ] '
opers[2]='GT  [ >  ] '
opers[3]='LT  [ <  ] '
opers[4]='GE  [ >= ] '
opers[5]='LE  [ <= ] '
opers[6]='BETWEEN    '
opers[7]='CONTAINS   '
opers[8]='SOUNDS LIKE'
opers[9]='BLANK or 0 '
PUBLIC preface[2]                                && preface for where selection
preface[1]=' is'                                 &&   of IS or IS NOT
preface[2]=' is not'
PUBLIC selall,fscnt
PUBLIC level,alevel[4]
alevel[1]='SELESECT()'                           && four functions
alevel[2]='SORTSECT()'
alevel[3]='WHERSECT()'
alevel[4]='DISPSECT()'
***MAIN SECTION***************************************************************
***
***  This is the body of the program. Everything is executed from here.
***  When you F10 to the next level, it executes the value of the next
***  element of the array. When you ESC back to the previous section, it
***  executes the previous element of the array.
***
******************************************************************************
level=1
DO WHILE m->level>0 .AND. m->level<5             && continue in 4 main sections
   temp=alevel[M->level]                         &&  until done
   level=&temp
ENDDO
DO ending
*****select section***********************************************************
FUNCTION selesect
Acopy(m->c_fld,m->a_fld)                         && copy from master array
Acopy(m->c_typ,m->a_fldtyp)
Ains(m->a_fld,1)
a_fld[1]='(ALL)'
a_fldlen=m->numflds+1
fscnt=0
selall=.F.
selstrg=m->srchstrg
CLEAR
@ 0,0 SAY 'FILE: '
SET COLOR TO &color2
@ 0,6 SAY m->mainfile
SET COLOR TO &color1
@ 1,0 TO 5,79 DOUBLE
@ 23,0 TO 23,79
KEYBOARD CHR(23)                                 && so MEMOEDIT just displays
Memoedit(m->selstrg,2,2,4,77,.F.)                && display the string at top
@ 6,0 TO 18,22 DOUBLE
SET COLOR TO &color2
@ 6,2 SAY '[SELECT]'
SET COLOR TO &color1
bottomline("Select fields to use  "+m->bottstrg)
clrbox(0)
fselect=Achoice(7,1,17,21,m->a_fld,.T.,"chfunc")
IF m->fselect=0 .AND. LASTKEY()=27
   RETURN 0
ENDIF
IF m->fselect>1
   Adel(m->a_fld,1)
   fselect=m->fselect-1
   fscnt=m->fscnt+1
   a_fldsel[M->fscnt]=TRIM(a_fld[M->fselect])
   selstrg=SUBS(m->selstrg,1,7)+TRIM(a_fld[M->fselect])+' '+SUBS(m->selstrg,12)
   Adel(m->a_fld,m->fselect)
   a_fldlen=m->a_fldlen-2
   DO WHILE .T.
      KEYBOARD CHR(23)
      Memoedit(m->selstrg,2,2,4,77,.F.)
      clrbox(0)
      fselect=Achoice(7,1,17,21,m->a_fld,.T.,"chfunc")
      IF m->fselect>0
         fscnt=m->fscnt+1
         a_fldsel[M->fscnt]=TRIM(a_fld[M->fselect])
         selstrg=SUBS(m->selstrg,1,AT("SORT",m->selstrg)-2)+', '+;
            TRIM(a_fld[M->fselect])+' '+SUBS(m->selstrg,AT("SORT",m->selstrg))
         Adel(m->a_fld,m->fselect)
         a_fldlen=m->a_fldlen-1
      ELSE
         IF LASTKEY()=27
            RETURN 0
         ELSE                                    && if F10 was pressed
            EXIT
         ENDIF
      ENDIF
   ENDDO
ELSE
   selall=.T.
   selstrg=SUBS(m->selstrg,1,7)+'ALL '+SUBS(m->selstrg,12)
ENDIF
RETURN 2                                         && go to next section
*****sorted by section*******************************************************
FUNCTION sortsect
Acopy(m->c_fld,m->a_fld)                         && copy from master array
Ains(m->a_fld,1)
a_fld[1]='(NONE)'
a_fldlen=m->numflds+1
indxold=m->indxby
indxby=""
srtstrg=m->selstrg
KEYBOARD CHR(23)
Memoedit(m->srtstrg,2,2,4,77,.F.)                && display select string
@ 6,1 TO 18,23 DOUBLE
SET COLOR TO &color2
@ 6,3 SAY '[SORTED BY]'
SET COLOR TO &color1
bottomline("Select sort order  "+m->bottstrg)
clrbox(1)
fselect=Achoice(7,2,17,22,m->a_fld,.T.,"chfunc")
IF m->fselect=0 .AND. LASTKEY()=27
   RETURN 1
ENDIF
IF m->fselect>1
   Adel(m->a_fld,1)
   fselect=m->fselect-1
   indxby=indx(TRIM(a_fld[M->fselect]),a_fldtyp[M->fselect])
   srtstrg=SUBS(m->srtstrg,1,AT("Y ___",m->srtstrg)+1)+TRIM(a_fld[M->fselect])+;
      ' '+SUBS(m->srtstrg,AT("WHERE",m->srtstrg))
   Adel(m->a_fld,m->fselect)
   a_fldlen=m->a_fldlen-2
   Adel(m->a_fldtyp,m->fselect)
   DO WHILE .T.
      KEYBOARD CHR(23)
      Memoedit(m->srtstrg,2,2,4,77,.F.)
      clrbox(1)
      fselect=Achoice(7,2,17,22,m->a_fld,.T.,"chfunc")
      IF m->fselect>0
         indxby=m->indxby+'+'+indx(TRIM(a_fld[M->fselect]),a_fldtyp[M->fselect])
         srtstrg=SUBS(m->srtstrg,1,AT("WHERE",m->srtstrg)-1)+'+ '+;
            TRIM(a_fld[M->fselect])+' '+SUBS(m->srtstrg,AT("WHERE",m->srtstrg))
         Adel(m->a_fld,m->fselect)
         a_fldlen=m->a_fldlen-1
         Adel(m->a_fldtyp,m->fselect)
      ELSE
         IF LASTKEY()=27
            RETURN 1                             && go to previous section
         ELSE
            EXIT                                 && continue if F10 pressed
         ENDIF
      ENDIF
   ENDDO
ELSE
   srtstrg=SUBS(m->srtstrg,1,AT("SORT",m->srtstrg)-1)+;
      SUBS(m->srtstrg,AT("WHERE",m->srtstrg))
ENDIF
IF m->indxby == m->indxold
   indxnew=.F.
ELSE
   indxnew=.T.
ENDIF
RETURN 3                                         && proceed to next section
***** where section *********************************************************
FUNCTION whersect
Acopy(m->c_fld,m->a_fld)
Acopy(m->c_typ,m->a_fldtyp)
Ains(a_fld,1)
a_fld[1]='(ALL)'
a_fldlen=m->numflds+1
@ 6,2 TO 18,24 DOUBLE
SET COLOR TO &color2
@ 6,4 SAY '[WHERE]'
SET COLOR TO &color1
critext=' '
swrstrg=m->srtstrg
DO WHILE .T.
   KEYBOARD CHR(23)
   Memoedit(m->swrstrg,2,2,4,77,.F.)
   bottomline("Select criteria  "+m->bottstrg)
   clrbox(2)
   critsel=Achoice(7,3,17,23,m->a_fld,.T.,"chfunc")
   IF m->critsel=0 .AND. LASTKEY()=27
      @ 6,24 CLEAR TO 18,24
      RETURN 2                                   && go to previous section
   ENDIF
   IF m->critsel<2 .AND. a_fld[1]='(ALL)'
      Adel(m->a_fld,1)
      EXIT
   ENDIF
   IF a_fld[1]='(ALL)'
      Adel(m->a_fld,1)
      a_fldlen=m->a_fldlen-1
      critsel=m->critsel-1
   ENDIF
   IF m->critsel=0
      IF RIGHT(TRIM(m->critext),5)='.AND.'
         critext=SUBS(m->critext,1,LEN(TRIM(m->critext))-5)
      ENDIF
      IF RIGHT(TRIM(m->critext),5)='.OR.'
         critext=SUBS(m->critext,1,LEN(TRIM(m->critext))-4)
      ENDIF
      EXIT
   ENDIF
   bottomline("Select operator ")
   @ 19,2 TO 21,78
   @ 20,4 SAY a_fld[M->critsel]
   ischoice=1
   @ 6,42 PROMPT ' IS '
   @ 6,48 PROMPT ' IS NOT '
   MENU TO ischoice
   @ 6,42 SAY SPACE(14)
   SET COLOR TO &color2
   IF m->ischoice=2
      @ 6,43 SAY ' IS NOT '
      negate="!"
   ELSE
      ischoice=1
      @ 6,45 SAY ' IS '
      negate=""
   ENDIF
   SET COLOR TO &color1
   @ 7,41 TO 17,53 DOUBLE
   operator=Achoice(8,42,16,52,m->opers)
   IF m->operator=0
      @ 6,25 CLEAR TO 18,78
      @ 19,0 CLEAR TO 21,79
      RETURN 2                                   && go to previous section
   ENDIF
   curfldnam=TRIM(a_fld[M->critsel])
   SET CURSOR ON
   DO CASE
   CASE m->operator=6                            && BETWEEN operator
      value=" "
      lvalue=.F.
      s_value=""
      bottomline("Enter field values")
      DO CASE
      CASE a_fldtyp[M->critsel]='C'
         STORE SPACE(20) TO cvalue,cvalue2
         @ 20,4 SAY m->curfldnam+preface[m->ischoice]+' btwn '
         @ 20,COL() GET m->cvalue
         @ 20,COL() SAY ' & '
         @ 20,COL() GET m->cvalue2
         READ
         critext=m->critext+m->negate+"("+m->curfldnam+">='"+TRIM(m->cvalue)+"' .AND. "+;
            m->curfldnam+"<='"+TRIM(m->cvalue2)+"')"
         s_value=preface[m->ischoice]+" btwn '"+TRIM(m->cvalue)+"' & '"+TRIM(m->cvalue2)+"'"
      CASE a_fldtyp[M->critsel]='D'
         STORE CTOD(" ") TO dvalue,dvalue2
         @ 20,4 SAY m->curfldnam+preface[m->ischoice]+' btwn '
         @ 20,COL() GET m->dvalue
         @ 20,COL() SAY ' & '
         @ 20,COL() GET m->dvalue2
         READ
         critext=m->critext+m->negate+"("+m->curfldnam+">=CTOD('"+DTOC(m->dvalue)+"') .AND. "+;
            m->curfldnam+"<=CTOD('"+DTOC(m->dvalue2)+"'))"
         s_value=preface[m->ischoice]+" btwn "+DTOC(m->dvalue)+" & "+DTOC(m->dvalue2)
      CASE a_fldtyp[M->critsel]='N'
         STORE 0 TO nvalue,nvalue2
         @ 20,4 SAY m->curfldnam+preface[m->ischoice]+' btwn '
         @ 20,COL() GET m->nvalue PICT '99999999'
         @ 20,COL() SAY ' & '
         @ 20,COL() GET m->nvalue2 PICT '99999999'
         READ
         critext=m->critext+m->negate+"("+m->curfldnam+">="+LTRIM(STR(m->nvalue))+" .AND. "+;
            m->curfldnam+"<="+LTRIM(STR(m->nvalue2))+")"
         s_value=preface[m->ischoice]+" btwn "+LTRIM(STR(m->nvalue))+" & "+LTRIM(STR(m->nvalue2))
      CASE a_fldtyp[M->critsel]='L'
         @ 20,4 SAY m->curfldnam+' = ' GET m->lvalue PICT 'Y'
         READ
         critext=m->critext+m->negate+"("+m->curfldnam+'='+IF(m->lvalue,".T.",".F.")+")"
         s_value=' = '+IF(m->lvalue,'Y','N')
      CASE a_fldtyp[CRITSEL]='M'
         STORE SPACE(20) TO cvalue,cvalue2
         @ 20,4 SAY m->curfldnam+preface[m->ischoice]+' btwn '
         @ 20,COL() GET m->cvalue
         @ 20,COL() SAY ' & '
         @ 20,COL() GET m->cvalue2
         READ
         critext=m->critext+m->negate+"("+m->curfldnam+">='"+TRIM(m->cvalue)+"' .AND. "+;
            m->curfldnam+"<='"+TRIM(m->cvalue2)+"')"
         s_value=preface[m->ischoice]+" btwn '"+TRIM(m->cvalue)+"' & '"+TRIM(m->cvalue2)+"'"
      ENDCASE
      IF TRIM(RIGHT(m->swrstrg,1)) = '_'
         swrstrg=SUBS(m->swrstrg,1,AT("WHERE",m->swrstrg)+5)+;
            m->curfldnam+TRIM(m->s_value)
      ELSE
         swrstrg=m->swrstrg+m->curfldnam+TRIM(m->s_value)
      ENDIF
   CASE m->operator=7                            && CONTAINS operator
      cvalue=SPACE(20)
      contstrg=IF(m->ischoice=1,' contains ',' does not contain ')
      @ 20,4 SAY m->curfldnam+m->contstrg GET m->cvalue
      READ
      IF m->cvalue=UPPER(m->cvalue)
         critext=m->critext+m->negate+"(at('"+TRIM(m->cvalue)+"',&curfldnam.)>0) "
      ELSE
         critext=m->critext+m->negate+"(at('"+UPPER(TRIM(m->cvalue))+;
                 "',upper(&curfldnam.))>0) "
      ENDIF
      IF TRIM(RIGHT(m->swrstrg,1)) = '_'
         swrstrg=SUBS(m->swrstrg,1,AT("WHERE",m->swrstrg)+5)+m->curfldnam+;
            m->contstrg+TRIM(m->cvalue)
      ELSE
         swrstrg=m->swrstrg+m->curfldnam+m->contstrg+TRIM(m->cvalue)
      ENDIF
   CASE m->operator=8                            && SOUNDS LIKE operator
      cvalue=SPACE(20)
      contstrg=IF(m->ischoice=1,' sounds like ',' does not sound like ')
      @ 20,4 SAY m->curfldnam+m->contstrg GET m->cvalue
      READ
      critext=m->critext+m->negate+"(soundex(&curfldnam.)=soundex('"+;
              TRIM(m->cvalue)+"'))"
      IF TRIM(RIGHT(m->swrstrg,1)) = '_'
         swrstrg=SUBS(m->swrstrg,1,AT("WHERE",m->swrstrg)+5)+m->curfldnam+;
            m->contstrg+TRIM(m->cvalue)
      ELSE
         swrstrg=m->swrstrg+m->curfldnam+m->contstrg+TRIM(m->cvalue)
      ENDIF
   CASE m->operator=9                            && BLANK operator
      contstrg=preface[m->ischoice]+' blank '
      critext=m->critext+m->negate+"empty("+m->curfldnam+")"
      IF TRIM(RIGHT(m->swrstrg,1)) = '_'
         swrstrg=SUBS(m->swrstrg,1,AT("WHERE",m->swrstrg)+5)+m->curfldnam+;
            m->contstrg
      ELSE
         swrstrg=m->swrstrg+m->curfldnam+m->contstrg
      ENDIF
   OTHERWISE
      value=" "
      dvalue=CTOD(" ")
      cvalue=SPACE(20)
      nvalue=0
      lvalue=.F.
      s_value=""
      s_negate=IF(m->ischoice=1,"",preface[2])
      zoper=SUBS(opers[M->operator],6,3)
      bottomline("Enter field values")
      DO CASE
      CASE a_fldtyp[M->critsel]='C'
         @ 20,4 SAY m->curfldnam+m->s_negate+m->zoper GET m->cvalue
         READ
         value="'"+TRIM(m->cvalue)+"'"
         s_value=m->value
      CASE a_fldtyp[M->critsel]='D'
         @ 20,4 SAY m->curfldnam+m->s_negate+m->zoper GET m->dvalue
         READ
         value="CTOD('"+DTOC(m->dvalue)+"')"
         s_value=DTOC(m->dvalue)
      CASE a_fldtyp[M->critsel]='N'
         @ 20,4 SAY m->curfldnam+m->s_negate+m->zoper GET m->nvalue PICT '99999999'
         READ
         value=LTRIM(STR(m->nvalue))
         s_value=m->value
      CASE a_fldtyp[M->critsel]='L'
         @ 20,4 SAY m->curfldnam+m->s_negate+m->zoper GET m->lvalue PICT 'Y'
         READ
         value=IF(m->lvalue,".T.",".F.")
         s_value=IF(m->lvalue,'Y','N')
      CASE a_fldtyp[CRITSEL]='M'
         @ 20,4 SAY m->curfldnam+m->s_negate+m->zoper GET m->cvalue
         READ
         value="'"+TRIM(m->cvalue)+"'"
         s_value=m->value
      ENDCASE
      critext=m->critext+m->negate+"("+m->curfldnam+m->zoper+' '+;
              TRIM(m->value)+")"
      IF TRIM(RIGHT(m->swrstrg,1)) = '_'
         swrstrg=SUBS(m->swrstrg,1,AT("WHERE",m->swrstrg)+5)+m->curfldnam
      ELSE
         swrstrg=m->swrstrg+m->curfldnam
      ENDIF
      swrstrg=m->swrstrg+m->s_negate+m->zoper+TRIM(m->s_value)
   ENDCASE
   @ 6,25 CLEAR TO 18,79
   @ 19,0 CLEAR TO 21,79
   SET CURSOR OFF
   KEYBOARD CHR(23)
   Memoedit(m->swrstrg,2,2,4,77,.F.)
   bottomline("Select option to continue")
   andor=1
   @ 7,36 TO 12,61 DOUBLE
   @ 8,37 PROMPT ' Use selected criteria  '
   @ 9,37 PROMPT ' Discard criteria       '
   @ 10,37 PROMPT ' AND (this and another) '
   @ 11,37 PROMPT ' OR  (this or another)  '
   MENU TO andor
   @ 7,32 CLEAR TO 12,61
   DO CASE
   CASE m->andor=0
      IF LASTKEY()=27
         @ 6,24 CLEAR TO 18,24
         RETURN 2
      ELSE
         EXIT
      ENDIF
   CASE m->andor=1
      EXIT
   CASE m->andor=2
      RETURN 3                                   && enter WHERE options again
   CASE m->andor=3
      critext=m->critext+' .AND. '
      swrstrg=m->swrstrg+' AND '
   CASE m->andor=4
      critext=m->critext+' .OR. '
      swrstrg=m->swrstrg+' OR '
   ENDCASE
ENDDO
RETURN 4                                         && proceed to final step
***DISPLAY SECTION************************************************************
FUNCTION dispsect
PUBLIC qscreen
SAVE SCREEN TO qscreen
SET COLOR TO *&color1
IF m->indxnew                                    && index if necessary
   IF EMPTY(m->indxby)
      SET INDEX TO
   ELSE
      bottomline('Indexing ... please wait')
      IF EMPTY(m->ifile)
         ifile=RAND('.NTX')                      && generate a unique filename
      ENDIF
      INDEX ON &indxby TO &ifile.
      SET INDEX TO &ifile.
      indxnew=.F.
   ENDIF
ENDIF
IF EMPTY(m->critext)                             && set a filter if necessary
   SET FILTER TO
ELSE
   bottomline('Selecting records ... please wait')
   SET FILTER TO &critext
ENDIF
SET COLOR TO &color1
GO TOP
IF EOF()
   bottomline('No records selected',0)
   RESTORE SCREEN FROM m->qscreen
   RETURN 3
ENDIF
CLEAR
@ 0,0 SAY 'FILE: '
SET COLOR TO &color2
@ 0,6 SAY m->mainfile
SET COLOR TO &color1
DECLARE KEY[2]
KEY[1]=' [F3] = help toggle   [F7] = print   [F8] = sum '+;
   '  [F9] = count  [F10] = exit'
KEY[2]=' ESC = backup      '+CHR(27)+' PgUp PgDn  '+;
   ' Crtl-PgUp = top    Ctrl-PgDn = bottom '
keyhelp=.T.
bottomline(KEY[1])
IF m->selall
   PUBLIC dbflds[fcount()]                       && copy into the live array
   Acopy(m->c_fld,m->dbflds)                           && either ALL fields
ELSE
   PUBLIC dbflds[M->fscnt]
   Acopy(m->a_fldsel,m->dbflds,1,m->fscnt)             && or those selected
ENDIF
Dbedit(1,0,23,79,dbflds,"userfunc",.T.,.T.,.T.,.T.,"")
IF LASTKEY()=27
   RESTORE SCREEN FROM m->qscreen
   RETURN 3
ENDIF
RETURN 5
******************************************************************************
FUNCTION indx                                    && change all indexing
PARA strg,ftyp                                   &&  parameters to text
DO CASE
CASE m->ftyp='C'
CASE m->ftyp='N'
   strg="str("+m->strg+",10)"
CASE m->ftyp='D'
   strg="DTOS("+m->strg+")"
CASE m->ftyp='L'
   strg=""
CASE m->ftyp='M'
ENDCASE
RETURN m->strg
******************************************************************************
FUNCTION clrbox
PARA Offset
@ 7,1+m->offset CLEAR TO 17,21+m->offset
RETURN .t.
******************************************************************************
FUNCTION userfunc                                && function for dbedit
PARA STATUS, fld_ptr
PRIVATE request
key_stroke=LASTKEY()
DO CASE
CASE m->status=4
   request=keyexcept(m->key_stroke)
OTHER
   request=1
ENDCASE
RETURN m->request
******************************************************************************
FUNCTION keyexcept                               && handling key exceptions
PARA action_key
DO CASE
CASE m->action_key=27 .OR. m->action_key=-9      && Escape
   RETURN 0
CASE m->action_key=13                            && Return
   e_field = dbflds[M->fld_ptr]
   IF TYPE(m->e_field) = "M"                     && If this is a MEMO field,
      memo_buff = Savescreen(6,5,22,75)          &&   let's see it.
      @ 7,6 TO 21,74
      SET COLOR TO &color2
      @ 7,((76 - LEN(m->e_field)) / 2) SAY '  '+UPPER(m->e_field)+'  '
      SET COLOR TO &color1
      bottomline(KEY[2])
      Memoedit(&e_field, 8,7,20,73,.F.)
      Restscreen(6,5,22,75,m->memo_buff)
      bottomline(KEY[1])
   ENDIF
   RETURN 1
CASE m->action_key=-2                            && F3 - key help
   IF m->keyhelp
      bottomline(KEY[2])
      keyhelp=.F.
   ELSE
      bottomline(KEY[1])
      keyhelp=.T.
   ENDIF
   RETURN 1
CASE m->action_key=-6                            && F7 - printing
   zprint=ptr()
   IF m->zprint>0
      bottomline("")
      mem_min=16
      mem_max=40
      plength=66
      lmargin=8
      pwidth=999
      IF m->zprint=1
         SAVE SCREEN
         pwidth=80
         @ 5,29 TO 9,51 DOUBLE
         @ 6,30 CLEAR TO 8,50
         @ 6,34 SAY 'Left margin:' GET m->lmargin PICT '999'
         @ 7,31 SAY 'Max page width:' GET m->pwidth PICT '999'
         @ 8,34 SAY 'Page length:' GET m->plength PICT '999'
         READ
         REST SCREEN
      ENDIF
      SET COLOR TO *&color1
      bottomline('Printing ... please wait')
      SET COLOR TO &color1
      thisrecord=RECNO()
      GO TOP
      Header='  '
      padding=0
      jwidth=1
      DO WHILE m->jwidth<=LEN(dbflds)            && determine which is longer,
         fldname=TRIM(dbflds[M->jwidth])         &&   field width or fieldname
         ztype=TYPE(m->fldname)
         DO CASE
         CASE m->ztype='D'
            padding=8-LEN(m->fldname)
         CASE m->ztype='L'
            padding=1-LEN(m->fldname)
         CASE m->ztype='N'
            dum=STR(&fldname.)
            padding=LEN(m->dum)-LEN(m->fldname)
         CASE m->ztype='M'
            leftover=m->pwidth-m->lmargin-LEN(m->header)-4
            IF m->leftover > m->mem_max
               leftover=m->mem_max
            ENDIF
            IF m->leftover < m->mem_min
               leftover=m->mem_min
            ENDIF
            padding=m->leftover-LEN(m->fldname)
         OTHER
            padding=LEN(&fldname.)-LEN(m->fldname)
         ENDCASE
         newheader=m->header+UPPER(m->fldname)+;
                   IIF(m->padding<0,"",SPACE(m->padding))+'  '
         IF LEN(m->newheader)>m->pwidth-m->lmargin-2
            Header=SUBS(m->header,1,m->pwidth-m->lmargin)
            EXIT
         ELSE
            header=m->newheader
         ENDIF
         jwidth=m->jwidth+1
      ENDDO
      jwidth=m->jwidth-1
      pagenum=1
      IF m->zprint=1
         IF !checkptr()
            GO m->thisrecord
            bottomline(KEY[1])
            RETURN 1
         ENDIF
      ENDIF
      SET CONS OFF
      SET DEVICE TO PRINT
      pagenum=printhdr(m->pagenum,m->header)
      DO WHILE !EOF()
         IF PROW()>m->plength-8
            pagenum=printhdr(m->pagenum,m->header)
         ENDIF
         @ PROW()+1,m->lmargin SAY "  "
         FOR J=1 TO m->jwidth
            fldname=TRIM(dbflds[M->j])
            ztype=TYPE(m->fldname)
            DO CASE
            CASE m->ztype='D'
               padding=LEN(m->fldname)-8
               ztext=DTOC(&fldname.)+IIF(m->padding<0,"",SPACE(m->padding))+'  '
            CASE m->ztype='L'
               padding=LEN(m->fldname)-1
               fpad=INT(m->padding/2)
               IF m->padding>0
                  ztext=SPACE(m->fpad)+convlog(&fldname.)+SPACE(m->padding-m->fpad)+'  '
               ELSE
                  ztext=convlog(&fldname.)
               ENDIF
            CASE m->ztype='N'
               dum=STR(&fldname.)
               padding=LEN(m->fldname)-LEN(m->dum)
               ztext=IIF(m->padding<0,"",SPACE(m->padding))+m->dum+'  '
            CASE m->ztype='M'
               memcol=PCOL()
               @ PROW(),m->memcol SAY Memoline(&fldname,m->leftover,1)+;
                  SPACE(m->mem_max+2-(PCOL()-m->memcol))
               FOR k=2 TO Mlcount(&fldname,m->leftover)
                  IF PROW()>m->plength-8
                     pagenum=printhdr(m->pagenum,m->header)
                  ENDIF
                  @ PROW()+1,m->memcol SAY Memoline(&fldname,m->leftover,m->k)
               NEXT
               ztext=""
            OTHER
               padding=LEN(m->fldname)-LEN(&fldname.)
               ztext=&fldname.+IIF(m->padding<0,"",SPACE(m->padding))+'  '
            ENDCASE
            @ PROW(),PCOL() SAY m->ztext
         NEXT
         SKIP
      ENDDO
      EJECT
      SET DEVICE TO SCREEN
      SET CONS ON
      GO m->thisrecord
   ENDIF
   bottomline(KEY[1])
   RETURN 1
CASE m->action_key=-7                            && F8
   SAVE SCRE TO sumthing
   IF m->numcnt=0
     bottomline('No numeric fields to sum',0)
   ELSE
      bottomline('Which field to sum?')
      @ 6,34 TO 16,45 DOUBLE
      @ 7,35 CLEAR TO 15,44
      npick=Achoice(7,35,15,44,m->a_numtyp)
      IF m->npick>0
         sumfld=a_numtyp[M->npick]
         bottomline('Summing '+TRIM(m->sumfld)+' ... please wait')
         rnum=RECNO()
         SUM &sumfld. TO snum
         bottomline('Summing '+TRIM(m->sumfld)+' = '+LTRIM(STR(m->snum)),0)
         bottomline(KEY[1])
         GO m->rnum
      ENDIF
   ENDIF
   REST SCRE FROM m->sumthing
   RETURN 1
CASE action_key=-8                               && F9
   bottomline('Counting records selected ... please wait')
   rnum=RECNO()
   IF EMPTY(m->critext)
      cnum=Lastrec()
   ELSE
      COUNT TO cnum
   ENDIF
   bottomline('Counting records selected  = '+LTRIM(STR(m->cnum)),0)
   bottomline(KEY[1])
   GO m->rnum
   RETURN 1
OTHER
   RETURN 1
ENDCASE
******************************************************************************
FUNCTION ptr                                     && decide where to send print
SAVE SCRE TO m->prtr2
@ 6,35 TO 9,45 DOUBLE
PUBLIC zptr
zptr=1
@ 7,36 PROMPT ' Printer '
@ 8,36 PROMPT ' File    '
MENU TO zptr
DO CASE
CASE m->zptr=0
CASE m->zptr=1
   SET PRINTER TO
CASE m->zptr=2
   zfile=SPACE(20)
   @ 10,28 CLEAR TO 12,61
   @ 11,30 SAY 'Filename' GET m->zfile
   READ
   zfile=TRIM(m->zfile)
   IF EMPTY(M->zfile)
      zptr=0
   ELSE
      SET PRINTER TO &zfile
   ENDIF
ENDCASE
REST SCRE FROM m->prtr2
RETURN m->zptr
*****************************************************************************
FUNCTION printhdr
PARA pagenum,header
IF m->pagenum > 1
   EJECT
ENDIF
@ PROW(),m->lmargin SAY 'File: '+UPPER(m->mainfile)
@ PROW()+1,m->lmargin SAY 'Page '+LTRIM(STR(m->pagenum))
@ PROW()+2,m->lmargin SAY m->header
@ PROW()+1,m->lmargin SAY REPL('-',LEN(m->header))
RETURN (m->pagenum+1)
*****************************************************************************
FUNCTION checkptr                                && make sure the printer is
DO WHILE !isprinter()                            &&   ready
   botline=savescreen(24,0,24,79)
   bottomline('Printer is not ready - press ESC to cancel',0)
   IF lastkey()=27
      RETURN .f.
   ENDIF
   restscreen(24,0,24,79,botline)
ENDDO
RETURN .t.
*****************************************************************************
FUNCTION RAND                                    && generate a unique filename
PARA extension
tstr='QQQQ0000'+m->extension
DO WHILE FILE(m->tstr)
   tstr='QQQQ'+SUBS(TIME(),7,2)+'00'+m->extension
ENDDO
RETURN m->tstr
*****************************************************************************
FUNCTION convlog                                 && convert logical data to
PARA logfld                                      &&  Y or N
RETURN IIF(m->logfld,'Y','N')
*****************************************************************************
FUNCTION chfunc                                  && key handling in menu selects
PARAMETERS amode, sel, rel
*** amode is the mode passed by achoice
*** sel is the currently selected item
*** rel is the relative position with the window
rr=2
DO CASE
CASE m->amode = 0                                  && mode 0 - idle
  @ 7,21+m->level say IF(m->sel > m->rel+1,"","")
  @ 17,21+m->level say IF(a_fldlen > (m->sel + 10 - m->rel),"","")
CASE m->amode = 3                                  && mode 3 - keystroke exception
   k = LASTKEY()
   DO CASE
   CASE m->k = 27 .OR. m->k=-9                   && Esc or F10 pressed
      rr = 0
   CASE m->k = 13                                && Enter pressed
      rr = 1
   CASE m->k = 1                                 && Home key pressed
      KEYBOARD CHR(31)
   CASE m->k = 6                                 && End key pressed
      KEYBOARD CHR(30)
   CASE isdata(m->k)
      rr=3
   ENDCASE
ENDCASE
RETURN m->rr
******************************************************************************
FUNCTION isdata                                  && was key pressed data?
PARAMETERS k
RETURN (m->k >= 32 .AND. m->k < 249 .AND. m->k <> 219 .AND. CHR(m->k) <> ";")
******************************************************************************
FUNCTION bottomline                              && to display along bottom
PARAMETERS typestrg,bottomfunc
@ 24,0
@ 24,0 SAY typestrg
IF Pcount()=2
   IF bottomfunc=1                               && to get string
      getstrg=SPACE(30)
      @ 24,COL()+1 GET m->getstrg
      READ
      RETURN TRIM(m->getstrg)
   ELSE                                          && to pause
      @ 24,COL() SAY ' ... press any key'
      INKEY(0)
   ENDIF
ENDIF
RETURN .T.
******************************************************************************
FUNCTION net_use                                 && simplified network USE
PARAMETERS FILE
WAIT=2
DO WHILE (m->WAIT > 0)
   USE &file                                     && shared
   IF .NOT. Neterr()                             && USE succeeds
      RETURN (.T.)
   ENDIF
   INKEY(1)                                      && wait 1 second
   WAIT = m->WAIT - 1
ENDDO
RETURN (.F.)                                     && USE fails
******************************************************************************
PROCEDURE opening
oplngth=LEN(openline)
FOR J=1 TO m->oplngth STEP 2
   @ 0,0 SAY SUBS(m->openline,m->oplngth-J)
   INKEY(.04)
NEXT
INKEY(1)
oline=Savescreen(0,0,0,79)                       && save opening line
bline=Savescreen(1,0,1,79)                       && save blank line
FOR J=1 TO 24                                    && walk it down the screen
   Restscreen(J,0,J,79,oline)
   Restscreen(J-1,0,J-1,79,bline)
   INKEY(.03)
NEXT
SET CURSOR ON
@ 23,0 TO 23,79
INKEY(2)                                         && wait 2 seconds
RETURN
******************************************************************************
PROCEDURE ending                                 && That's all folks
CLOSE ALL
IF FILE(m->ifile)                                && kill the index file
   ERASE &ifile.
ENDIF
@ m->oldrow-1,0                                  && go back to starting line
REST SCRE FROM m->tscrn
SET CURSOR ON
QUIT
*: EOF: QUERY.PRG
